// -*- C++ -*-

//#include "Nautilus.h"
#include "AdjModel.h"
#include "avars.h"
#include <gfx/tools/Heap.h>
#include <iostream>
#include <fstream>

namespace simplif
{
	class pair_info : public Heapable
	{
		public:
			Vertex *v0, *v1;

			Vec3 candidate;
			real cost;

			pair_info(Vertex *a,Vertex *b) { v0=a; v1=b; cost=HUGE; }

			bool isValid() { return v0->isValid() && v1->isValid(); }
	};

	typedef buffer<pair_info *> pair_buffer;

	class vert_info
	{
		public:

			pair_buffer pairs;

			Mat4 Q;
			real norm;

			vert_info() : Q(Mat4::zero) { pairs.init(2); norm=0.0; }
	};
}

